package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLSchedule_userImport) ENABLED START ***/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLSchedule extends JNIObject  {
	
	/* @generated */
	protected ISLSchedule(long ptr) {
		/*** PROTECTED REGION ID(ISLSchedule_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLSchedule build(long ptr) {
		return new ISLSchedule(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLSchedule_userCode) ENABLED START ***/
	
	/**
	 * See http://www.kotnet.org/~skimo/isl/user.html#options
	 * 
	 * @author amorvan
	 *
	 */
	public static class JNIISLSchedulingOptions {
		// Values from "include/isl/options.h" in ISL sources.
		public static final int ISL_SCHEDULE_ALGORITHM_ISL = 0;
		public static final int ISL_SCHEDULE_ALGORITHM_FEAUTRIER = 1;

		// Values from "include/isl/schedule.h" in ISL sources.
		public static final int ISL_SCHEDULE_FUSE_MAX = 0;
		public static final int ISL_SCHEDULE_FUSE_MIN = 1;

		public static final int DEFAULT_MAX_COEF = -1; //disable bound on coefs.
		public static final int DEFAULT_MAX_CONSTANT_TERM = -1; //disable bound on coefs.
		public static final int DEFAULT_FUSE = ISL_SCHEDULE_FUSE_MAX;
		public static final int DEFAULT_MAXIMIZE_BAND_DEPTH = 0;
		public static final int DEFAULT_OUTER_ZERO_DISTANCE = 0;
		public static final int DEFAULT_Split_scaled = 1;
		public static final int DEFAULT_ALGORITHM = ISL_SCHEDULE_ALGORITHM_ISL;
		public static final int DEFAULT_SEPARATE_COMPONENTS = 0;

		private int max_coefficient;
		private int max_constant_term;
		private int fuse;
		private int maximize_band_depth;
		private int outer_zero_distance;
		private int split_scaled;
		private int algorithm;
		private int separate_components;

		public JNIISLSchedulingOptions() {
			this(DEFAULT_MAX_COEF, DEFAULT_MAX_CONSTANT_TERM, DEFAULT_FUSE,
					DEFAULT_MAXIMIZE_BAND_DEPTH, DEFAULT_OUTER_ZERO_DISTANCE,
					DEFAULT_Split_scaled, DEFAULT_ALGORITHM,
					DEFAULT_SEPARATE_COMPONENTS);
		}

		public JNIISLSchedulingOptions(int max_coefficient,
				int max_constant_term, int fuse, int maximize_band_depth,
				int outer_zero_distance, int split_scaled, int algorithm,
				int separate_components) {
			this.max_coefficient = max_coefficient;
			this.max_constant_term = max_constant_term;
			this.fuse = fuse;
			this.maximize_band_depth = maximize_band_depth;
			this.outer_zero_distance = outer_zero_distance;
			this.split_scaled = split_scaled;
			this.algorithm = algorithm;
			this.separate_components = separate_components;
		}

		public int getMax_coefficient() {
			return max_coefficient;
		}

		public void setMax_coefficient(int max_coefficient) {
			this.max_coefficient = max_coefficient;
		}

		public int getFuse() {
			return fuse;
		}

		public void setFuse(int fuse) {
			this.fuse = fuse;
		}

		public int getSeparate_components() {
			return separate_components;
		}

		public void setSeparate_components(int separate_components) {
			this.separate_components = separate_components;
		}

		public int getMax_constant_term() {
			return max_constant_term;
		}

		public void setMax_constant_term(int max_constant_term) {
			this.max_constant_term = max_constant_term;
		}

		public int getMaximize_band_depth() {
			return maximize_band_depth;
		}

		public void setMaximize_band_depth(int maximize_band_depth) {
			this.maximize_band_depth = maximize_band_depth;
		}

		public int getOuter_zero_distance() {
			return outer_zero_distance;
		}

		public void setOuter_zero_distance(int outer_zero_distance) {
			this.outer_zero_distance = outer_zero_distance;
		}

		public int getSplit_scaled() {
			return split_scaled;
		}

		public void setSplit_scaled(int split_scaled) {
			this.split_scaled = split_scaled;
		}

		public int getAlgorithm() {
			return algorithm;
		}

		public void setAlgorithm(int algorithm) {
			this.algorithm = algorithm;
		}
	}

	public static ISLSchedule computeFeautrierSchedule(
			ISLUnionSet domains, ISLUnionMap prdg) {
		return computeSchedule(domains, prdg,
				JNIISLSchedulingOptions.ISL_SCHEDULE_ALGORITHM_FEAUTRIER);
	}

	public static ISLSchedule computeFeautrierSchedule(
			ISLUnionSet domains, ISLUnionMap validity,
			ISLUnionMap proximity) {
		return computeSchedule(domains, validity, proximity,
				JNIISLSchedulingOptions.ISL_SCHEDULE_ALGORITHM_FEAUTRIER);
	}

	public static ISLSchedule computePlutoSchedule(ISLUnionSet domains,
			ISLUnionMap prdg) {
		return computeSchedule(domains, prdg,
				JNIISLSchedulingOptions.ISL_SCHEDULE_ALGORITHM_ISL);
	}

	public static ISLSchedule computePlutoSchedule(ISLUnionSet domains,
			ISLUnionMap validity, ISLUnionMap proximity) {
		return computeSchedule(domains, validity, proximity,
				JNIISLSchedulingOptions.ISL_SCHEDULE_ALGORITHM_ISL);
	}

	public static ISLSchedule computeSchedule(ISLUnionSet domains,
			ISLUnionMap validity, ISLUnionMap proximity, int algo) {
		JNIISLSchedulingOptions options = new JNIISLSchedulingOptions();
		options.setAlgorithm(algo);
		return computeSchedule(domains, validity, proximity, options);
	}

	public static ISLSchedule computeSchedule(ISLUnionSet domains,
			ISLUnionMap prdg, int algo) {
		JNIISLSchedulingOptions options = new JNIISLSchedulingOptions();
		options.setAlgorithm(algo);
		return computeSchedule(domains, prdg, options);
	}

	public static ISLSchedule computeSchedule(ISLUnionSet domains,
			ISLUnionMap prdg, JNIISLSchedulingOptions options) {
		ISLUnionMap copy = prdg.copy();
		return computeSchedule(domains, copy, prdg, options);
	}

	public static ISLSchedule computeSchedule(ISLUnionSet domains,
			ISLUnionMap validity, ISLUnionMap proximity,
			JNIISLSchedulingOptions options) {
		ISLSchedule res = ISLSchedule.compute(ISLContext.getInstance(),
				domains, validity, proximity,

				options.getMax_coefficient(), options.getMax_constant_term(),
				options.getFuse(), options.getMaximize_band_depth(),
				options.getOuter_zero_distance(), options.getSplit_scaled(),
				options.getAlgorithm(), options.getSeparate_components());
		return res;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLSchedule buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_schedule_empty) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_from_domain 
	 * 
	@take domain
	 * @generated
	**/
	 public static ISLSchedule buildFromDomain(ISLUnionSet domain) { 
		/*** PROTECTED REGION ID(static_isl_schedule_from_domain) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(domain);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_from_domain(getNativePtr(domain)));
			} finally {
				taken(domain);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLSchedule buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_schedule_read_from_str) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_compute_schedule 
	 * 
	@take domain validity proximity
	 * @generated
	**/
	 public static ISLSchedule compute(ISLContext ctx, ISLUnionSet domain, ISLUnionMap validity, ISLUnionMap proximity, int max_coefficient, int max_constant_term, int fuse, int maximize_band_depth, int outer_coincidence, int split_scaled, int algorithm, int separate_components) { 
		/*** PROTECTED REGION ID(static_isl_compute_schedule) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(domain, validity, proximity);
			try {
				res = ISLSchedule.build(ISLNative.isl_compute_schedule(getNativePtr(ctx), getNativePtr(domain), getNativePtr(validity), getNativePtr(proximity), max_coefficient, max_constant_term, fuse, maximize_band_depth, outer_coincidence, split_scaled, algorithm, separate_components));
			} finally {
				taken(domain);
				taken(validity);
				taken(proximity);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLSchedule s, int format) { 
		/*** PROTECTED REGION ID(static_isl_schedule_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_to_string(getNativePtr(s), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_schedule_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_schedule_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_copy 
	 * 
	 * @generated
	**/
	public ISLSchedule copy() {
		/*** PROTECTED REGION ID(isl_schedule_copy) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_schedule_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_schedule_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLSchedule schedule2) {
		/*** PROTECTED REGION ID(isl_schedule_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_schedule_plain_is_equal(getNativePtr(this), getNativePtr(schedule2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_get_domain 
	 * 
	 * @generated
	**/
	public ISLUnionSet getDomain() {
		/*** PROTECTED REGION ID(isl_schedule_get_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_schedule_get_domain(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_get_map 
	 * 
	 * @generated
	**/
	public ISLUnionMap getMap() {
		/*** PROTECTED REGION ID(isl_schedule_get_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_schedule_get_map(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_insert_partial_schedule 
	 * 
	 * @take this partial
	 * @generated
	**/
	public ISLSchedule insertPartialSchedule(ISLMultiUnionPWAff partial) {
		/*** PROTECTED REGION ID(isl_schedule_insert_partial_schedule) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, partial);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_insert_partial_schedule(getNativePtr(this), getNativePtr(partial)));
			} finally {
				taken(this);
				taken(partial);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_insert_context 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLSchedule insertContext(ISLSet context) {
		/*** PROTECTED REGION ID(isl_schedule_insert_context) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_insert_context(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_insert_guard 
	 * 
	 * @take this guard
	 * @generated
	**/
	public ISLSchedule insertGuard(ISLSet guard) {
		/*** PROTECTED REGION ID(isl_schedule_insert_guard) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, guard);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_insert_guard(getNativePtr(this), getNativePtr(guard)));
			} finally {
				taken(this);
				taken(guard);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_sequence 
	 * 
	 * @take this schedule2
	 * @generated
	**/
	public ISLSchedule sequence(ISLSchedule schedule2) {
		/*** PROTECTED REGION ID(isl_schedule_sequence) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, schedule2);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_sequence(getNativePtr(this), getNativePtr(schedule2)));
			} finally {
				taken(this);
				taken(schedule2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_set 
	 * 
	 * @take this schedule2
	 * @generated
	**/
	public ISLSchedule set(ISLSchedule schedule2) {
		/*** PROTECTED REGION ID(isl_schedule_set) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, schedule2);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_set(getNativePtr(this), getNativePtr(schedule2)));
			} finally {
				taken(this);
				taken(schedule2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_intersect_domain 
	 * 
	 * @take this domain
	 * @generated
	**/
	public ISLSchedule intersectDomain(ISLUnionSet domain) {
		/*** PROTECTED REGION ID(isl_schedule_intersect_domain) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, domain);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_intersect_domain(getNativePtr(this), getNativePtr(domain)));
			} finally {
				taken(this);
				taken(domain);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_gist_domain_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLSchedule gistDomainParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_schedule_gist_domain_params) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_gist_domain_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_reset_user 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSchedule resetUser() {
		/*** PROTECTED REGION ID(isl_schedule_reset_user) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_reset_user(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_align_params 
	 * 
	 * @take this space
	 * @generated
	**/
	public ISLSchedule alignParams(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_schedule_align_params) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, space);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_align_params(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(this);
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_pullback_union_pw_multi_aff 
	 * 
	 * @take this upma
	 * @generated
	**/
	public ISLSchedule pullback(ISLUnionPWMultiAff upma) {
		/*** PROTECTED REGION ID(isl_schedule_pullback_union_pw_multi_aff) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, upma);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_pullback_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma)));
			} finally {
				taken(this);
				taken(upma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_expand 
	 * 
	 * @take this contraction expansion
	 * @generated
	**/
	public ISLSchedule expand(ISLUnionPWMultiAff contraction, ISLSchedule expansion) {
		/*** PROTECTED REGION ID(isl_schedule_expand) DISABLED START ***/
		ISLSchedule res;
		
		synchronized(LOCK) {
			checkParameters(this, contraction, expansion);
			try {
				res = ISLSchedule.build(ISLNative.isl_schedule_expand(getNativePtr(this), getNativePtr(contraction), getNativePtr(expansion)));
			} finally {
				taken(this);
				taken(contraction);
				taken(expansion);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_schedule_get_root 
	 * 
	 * @generated
	**/
	public ISLScheduleNode getRoot() {
		/*** PROTECTED REGION ID(isl_schedule_get_root) DISABLED START ***/
		ISLScheduleNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLScheduleNode.build(ISLNative.isl_schedule_get_root(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLSchedule_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
